<template>
<div>
  <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
    <p>{{ error }}</p>
  </base-dialog>
  <section>
    <coach-filter @change-filter="changeFilter"></coach-filter>
  </section>
  <section>
    <base-card>
      <div class="controls">
        <base-button mode="outline" @click="loadCoaches(true)">Refresh</base-button>
        <base-button link to='/auth?redirect=register' v-if='!isLoggedIn'>Login to register as coach</base-button>
        <base-button v-if="isLoggedIn && !isCoach && !isLoading" link to="/register">Register as coach</base-button>
      </div>
      <div v-if="isLoading">
        <base-spinner></base-spinner>
      </div>
      <ul v-else-if="hasCoaches">
        <coach-list-item
          v-for="coach in filterCoaches" :key="coach.id"
          :firstName="coach.firstName"
          :lastName="coach.lastName"
          :areas="coach.areas"
          :id="coach.id"
          :rate="coach.hourlyRate"
        ></coach-list-item>
      </ul>
      <h3 v-else>No coach found!</h3>
    </base-card>
  </section>
</div>
</template>

<script>
import CoachListItem from './CoachListItem';
import CoachFilter from './CoachFilter';

export default {
  name: 'CoachList',
  components: {
    CoachListItem,
    CoachFilter,
  },
  data(){
    return {
      isLoading: false,
      error: null,
      activeFilter:{
        frontend: true,
        backend: true,
        career: true
      },
    };
  },
  created(){
    this.loadCoaches();
  },
  methods:{
    changeFilter(updateFilter){
      this.activeFilter = updateFilter;
    },
    handleError(){
      this.error = null;
    },
    async loadCoaches(bool = false){
      
      this.isLoading = true;
      try{
        await this.$store.dispatch('coach/loadCoaches',{forceRefresh:bool});

      }catch(error){
        this.error = error.message || 'Something went wrong!';
      }
      this.isLoading = false;
    },
  },
  computed:{
    isLoggedIn(){
      return this.$store.getters.isAuthenticated;
    },
    hasCoaches(){
      return !this.isLoading && this.$store.getters['coach/hasCoach']
    },
    isCoach(){
      return this.$store.getters['coach/isCoach']
    },
    filterCoaches(){
      return this.$store.getters['coach/getCoaches'].filter((ci)=>{
        if(this.activeFilter.frontend && ci.areas.includes('frontend')){
          return true;
        }
        if(this.activeFilter.backend && ci.areas.includes('backend')){
          return true;
        }
        if(this.activeFilter.career && ci.areas.includes('career')){
          return true;
        }
        return false;
      });
    },
  },
};
</script>

<style scoped>
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.controls {
  display: flex;
  justify-content: space-between;
}
</style>